# oneM2M TR-0076 Specification

This repository hosts the oneM2M TR-0076 specification defined by oneM2M Partnership project.

## Available versions

All available baselines produced from this repository are available at [TR-0076-baselines](https://specifications.onem2m.org/tr-0076/) (**URL available only if there is at least one baseline**)

## How to raise issues

Please report errors, bugs or other issues [here](https://git.onem2m.org/specifications/tr-0076/issues) or [here](https://git.onem2m.org/issues/issues).

## How to contribute

oneM2M permits the use of Gitlab to manage contributions to this specification.
For more information, visit the [oneM2M Gitlab contribution procedure](https://git.onem2m.org/tools/contribution-procedure).

## Available tools

A set of tools is used by this repository to facilitate the contribution management:

- Autogeneration of Word CR documents:
    - Upon creation of a Merge Request, a pipeline is executed to produce the associated Word CR document that contains the tracked changes proposed by the Merge Request.
    - Right after creation of a Merge Request, the source branch is protected in order to avoid any further change to the submitted contribution

- Publication of a new baseline
    - Upon creation of tag, a Word document will be generated from the markdown specification in this repository and published at the [TR-0076 specifications](https://specifications.onem2m.org/tr-0076/)
    - As Table of Content is not used in the markdown specfication document of this repository. A tool will generate the ToC and add it to the any new published baseline.

Please, refer to [Tools/Scripts repository](hhtps://git.onem2m.org/tools/scripts) for more details.

Some known issues:

- Generation of Word CR:
    - Additions/deletions of images will not appear as tracked change in the Word CR
    - Additions/deletions of a list of elements will make the list appearing as not enumerated in the Word CR
    - Changes in the first row of a table will break the conversion of such table to Word, the markdown table source code will be seen
    - Changes in clause titles will break the conversion of corresponding headings to Word, the markdown heading code will be seen
